#include <bits/stdc++.h>
#define pb push_back
#define ll long long int
#define pi pair<int, int>
#define all(x) x.begin(), x.end()

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll t, n, k;
    cin>>t>>n>>k;
    vector<ll> a(n);
    bool tc1=true;
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
        if(a[i]!=a[0])
        {
            tc1=false;
        }
    }
    if(tc1)
    {
        ll rez=0;
        if(n>abs(a[0]) && (n%2)!=(abs(a[0])%2)) rez=a[0]+1;
        else if(n>abs(a[0]) && (n%2)==(abs(a[0])%2)) rez=a[0];
        else if(n==abs(a[0])) rez=a[0];
        else rez=n*(a[0]/abs(a[0]));
        if(k!=rez) cout<<"NE\n";
        else
        {
            cout<<"DA\n";
            if(t==1) for(int i=0; i<n; i++) cout<<a[i]<<" ";
        }
    }

}